package message;

import message.content.ObjectClassHandleArraySizeObjectTagHandleArrayValueArrayResignActionBoolean;
import message.content.ValueArrayElement;

/**
 * 
* @author <a href = "mailto:yannick.bisiaux@supaero.fr">Yannick Bisiaux</a>, <a href = "mailto:ronan.bossard@supaero.fr">Ronan Bossard</a>, <a href = "mailto:samuel.reese@supaero.fr">Samuel Reese</a>
* @version 1.0
 *
 */
@SuppressWarnings("serial")
public class MSG_Reflect_Attribute_Values extends Message {
	private ObjectClassHandleArraySizeObjectTagHandleArrayValueArrayResignActionBoolean
			oClHArSzOTHArValArRActBool;
	
	/**
	 * @return default Reflect_Attribute_Values message
	 */
	public MSG_Reflect_Attribute_Values(){
		super(Type.REFLECT_ATTRIBUTE_VALUES);
		this.oClHArSzOTHArValArRActBool =
			new ObjectClassHandleArraySizeObjectTagHandleArrayValueArrayResignActionBoolean
					((long) 0, (short) 0, (long) 0, "", null, null, 0, false);
	}
	
	/**
	 * @return Reflect_Attribute_Values message
	 */
	public MSG_Reflect_Attribute_Values(Exception exception,
			FederationTime fed_Time, long oClass, short hArrSize, long obj,
			String tag, byte[] hArr, ValueArrayElement[] valArr,
			int resAction, boolean bool){
		super(Type.REFLECT_ATTRIBUTE_VALUES, exception, fed_Time);
		this.oClHArSzOTHArValArRActBool =
			new ObjectClassHandleArraySizeObjectTagHandleArrayValueArrayResignActionBoolean
					(oClass, hArrSize, obj, tag, hArr, valArr, resAction, bool);
	}
	
	/**
	 * Writes the message to a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>objectClass</code>, <code>handleArraySize</code>,
	 * <code>object</code>, <code>tag</code>,
	 * <code>handleArray</code>, <code>valueArray</code>,
	 * <code>resignAction</code>, <code>boolean</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * to which the message is written.
	 */
	public void writeObject(MessageBuffer msgBuffer){
		super.writeObject(msgBuffer);
		this.oClHArSzOTHArValArRActBool.writeObject(msgBuffer);
	}

	/**
	 * Reads the message from a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>objectClass</code>, <code>handleArraySize</code>,
	 * <code>object</code>, <code>tag</code>,
	 * <code>handleArray</code>, <code>valueArray</code>,
	 * <code>resignAction</code>, <code>boolean</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * from which the message is read.
	 */
	public void readObject(MessageBuffer msgBuffer){
		super.readObject(msgBuffer);
		this.oClHArSzOTHArValArRActBool.readObject(msgBuffer);
	}
	
	public String toString(){
		return (super.toString() + this.oClHArSzOTHArValArRActBool);
	}

}
